# hgm_batch_erf
#
# 
# Sample code
#
"""
import numpy as np
import hgm_batch_erf
import batch_data_loader
import matplotlib.pyplot as plt
fName='../hgm-ntk/Data/test_input3.csv'
dat = np.loadtxt(fName)
[dat2,removed,removed_small_covar]=batch_data_loader.cook_Q_for_hgm(dat,small_covar=1e-3,threshould=1e-5);

# dat2 を図示.
[pos1,pos2]=[0,1]; to=dat2.shape[0]
plt.plot(dat2.T[pos1][0:to],dat2.T[pos2][0:to],color='blue')
plt.show()

# 期待値をまとめて(all at once)計算.
#sol=hgm_batch_erf.batch_hgm_erf(dat2,qsize=30)  # 30個のみ計算
sol=hgm_batch_erf.batch_hgm_erf(dat2,qsize=-1)   # 全部計算.
print('Expectation values are in sol.y[0].')
"""
#
# changelog
#   2024-09-13-hgm-batch-erf
#
# Note
#
#Do pip3 install --upgrade --force-reinstall scipy on Ubuntu 20.04
# P11, P12, P22 are Pfaffian matrices for ReLU. x11, x12, x22 are x_{11}, x_{12}, x_{22}.
#
import numpy as np
from scipy.integrate import solve_ivp
import time

global N_calls
global Q
global Last_value

# 

def f_erf(t,f):
  global Q
  global N_calls
  N_calls = N_calls+1
  k = int(np.floor(t))
  dx=Q[k+1]-Q[k]
  [x11,x12,x22]=Q[k]+dx*(t-k)

#------ from tmp_pf_erf.py
  d1=-((x12)**(2))+(x22)*(x11)
  d2=(x12)**(2)+-((x22)*(x11))+x22
  d3=(x12)**(2)+((-(x22)+1) )*(x11)
  d4=(x12)**(2)+((-(x22)+1) )*(x11)+(x22)-(1)
  d5=(x12)**(4)+((-((x22)**(2))+x22) )*((x11)**(2))+((((x22)**(2))-(x22)) )*(x11)
  p11=np.array([[0,1,0,0,0,0,0,0],[(-3/2)/(((x11)**(2))-(x11)),(-((7/2)*(x11))+2)/(((x11)**(2))-(x11)),(-((3/2)*(x12)))/(((x11)**(2))-(x11)),0,0,(((-(x11)+1/2) )*(x12))/(((x11)**(2))-(x11)),(-((x12)**(2)))/(((x11)**(2))-(x11)),0],[0,0,0,0,0,1,0,0],[0,0,0,0,0,0,1,0],[0,0,0,0,0,0,0,1],[0,(((((6)*(x11))-(3)) )*((x12)**(3)))/(((d5)*((x11)**(2)))-((d5)*(x11))),(-3)/(((x11)**(2))-(x11)),(((((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)+((3)*((x22)**(2)))-((3)*(x22))) )*(x12))/(((d5)*((x11)**(2)))-((d5)*(x11))),(((((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)+((3)*((x22)**(2)))-((3)*(x22))) )*((x12)**(2)))/(((d5)*((x11)**(2)))-((d5)*(x11))),(((((3/2)*(x11))-(1/2)) )*((x12)**(4))+((((9/2)*((x22)**(2)))-((9/2)*(x22))) )*((x11)**(3))+((-((7)*((x22)**(2)))+(7)*(x22)) )*((x11)**(2))+((((5/2)*((x22)**(2)))-((5/2)*(x22))) )*(x11))/(((d5)*((x11)**(2)))-((d5)*(x11))),(-((8)*((x12)**(5)))+((((((14)*(x22))-(8)) )*(x11)+-((7)*(x22))+4) )*((x12)**(3))+((((-((6)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))+((((7)*((x22)**(2)))-((7)*(x22))) )*(x11)+-((4)*((x22)**(2)))+(4)*(x22)) )*(x12))/(((d5)*((x11)**(2)))-((d5)*(x11))),(-((x12)**(6))+((((((4)*(x22))-(2)) )*(x11)+-((2)*(x22))+1) )*((x12)**(4))+((((-((3)*((x22)**(2)))+(3)*(x22)) )*((x11)**(2))+((((3)*((x22)**(2)))-((3)*(x22))) )*(x11)+-((x22)**(2))+x22) )*((x12)**(2)))/(((d5)*((x11)**(2)))-((d5)*(x11)))],[0,(-((3/2)*((x12)**(2))))/(d5),0,(((3/2)*((x22)**(2)))-((3/2)*(x22)))/(d5),(((((3/2)*((x22)**(2)))-((3/2)*(x22))) )*(x12))/(d5),(-((3/2)*((x12)**(3))))/(d5),(((-((7/2)*(x22))+2) )*((x12)**(2))+((((7/2)*((x22)**(2)))-((7/2)*(x22))) )*(x11)+-((2)*((x22)**(2)))+(2)*(x22))/(d5),(((-(x22)+1/2) )*((x12)**(3))+((((((x22)**(2))-(x22)) )*(x11)+-((1/2)*((x22)**(2)))+(1/2)*(x22)) )*(x12))/(d5)],[(((-((9)*(x22))+9/2) )*((x12)**(3))+((((((9)*((x22)**(2)))-((9)*(x22))) )*(x11)+-((9/2)*((x22)**(2)))+(9/2)*(x22)) )*(x12))/((((d4)*(d3))*(d2))*(d1)),(-((12)*((x12)**(9)))+((((((48)*(x22))-(24)) )*(x11)+-((24)*(x22))+12) )*((x12)**(7))+(((((-((69)*((x22)**(2)))+(141/2)*(x22))-(6)) )*((x11)**(2))+((((69)*((x22)**(2)))-((141/2)*(x22))+6) )*(x11)+-((12)*((x22)**(2)))+(12)*(x22)) )*((x12)**(5))+((((((42)*((x22)**(3)))-((129/2)*((x22)**(2)))+(45/2)*(x22)) )*((x11)**(3))+(((-((129/2)*((x22)**(3)))+(99)*((x22)**(2)))-((69/2)*(x22))) )*((x11)**(2))+((((45/2)*((x22)**(3)))-((69/2)*((x22)**(2)))+(12)*(x22)) )*(x11)) )*((x12)**(3))+(((((-((9)*((x22)**(4)))+(18)*((x22)**(3)))-((9)*((x22)**(2)))) )*((x11)**(4))+((((39/2)*((x22)**(4)))-((39)*((x22)**(3)))+(39/2)*((x22)**(2))) )*((x11)**(3))+(((-((33/2)*((x22)**(4)))+(33)*((x22)**(3)))-((33/2)*((x22)**(2)))) )*((x11)**(2))+((((6)*((x22)**(4)))-((12)*((x22)**(3)))+(6)*((x22)**(2))) )*(x11)) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((27)*(x22))+27/2) )*((x12)**(4))+((((((27)*((x22)**(2)))-((27)*(x22))) )*(x11)+-((27/2)*((x22)**(2)))+(27/2)*(x22)) )*((x12)**(2)))/((((d4)*(d3))*(d2))*(d1)),(((((24)*((x22)**(2)))-((24)*(x22))) )*((x12)**(7))+(((((-((69)*((x22)**(3)))+(207/2)*((x22)**(2)))-((69/2)*(x22))) )*(x11)+((36)*((x22)**(3)))-((54)*((x22)**(2)))+(18)*(x22)) )*((x12)**(5))+(((((((66)*((x22)**(4)))-((267/2)*((x22)**(3)))+(147/2)*((x22)**(2)))-((6)*(x22))) )*((x11)**(2))+(((-((135/2)*((x22)**(4)))+(273/2)*((x22)**(3)))-((75)*((x22)**(2)))+(6)*(x22)) )*(x11)+((18)*((x22)**(4)))-((36)*((x22)**(3)))+(18)*((x22)**(2))) )*((x12)**(3))+(((((-((21)*((x22)**(5)))+(54)*((x22)**(4)))-((45)*((x22)**(3)))+(12)*((x22)**(2))) )*((x11)**(3))+(((((63/2)*((x22)**(5)))-((81)*((x22)**(4)))+(135/2)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))+(((-((21/2)*((x22)**(5)))+(27)*((x22)**(4)))-((45/2)*((x22)**(3)))+(6)*((x22)**(2))) )*(x11)) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((21)*((x22)**(2)))-((21)*(x22))) )*((x12)**(8))+(((((-((69)*((x22)**(3)))+(207/2)*((x22)**(2)))-((69/2)*(x22))) )*(x11)+((36)*((x22)**(3)))-((54)*((x22)**(2)))+(18)*(x22)) )*((x12)**(6))+(((((((72)*((x22)**(4)))-((291/2)*((x22)**(3)))+(159/2)*((x22)**(2)))-((6)*(x22))) )*((x11)**(2))+(((-((147/2)*((x22)**(4)))+(297/2)*((x22)**(3)))-((81)*((x22)**(2)))+(6)*(x22)) )*(x11)+((18)*((x22)**(4)))-((36)*((x22)**(3)))+(18)*((x22)**(2))) )*((x12)**(4))+(((((-((21)*((x22)**(5)))+(54)*((x22)**(4)))-((45)*((x22)**(3)))+(12)*((x22)**(2))) )*((x11)**(3))+(((((63/2)*((x22)**(5)))-((81)*((x22)**(4)))+(135/2)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))+(((-((21/2)*((x22)**(5)))+(27)*((x22)**(4)))-((45/2)*((x22)**(3)))+(6)*((x22)**(2))) )*(x11)) )*((x12)**(2))+(((-((3)*((x22)**(6)))+(9)*((x22)**(5)))-((9)*((x22)**(4)))+(3)*((x22)**(3))) )*((x11)**(4))+(((((6)*((x22)**(6)))-((18)*((x22)**(5)))+(18)*((x22)**(4)))-((6)*((x22)**(3)))) )*((x11)**(3))+(((-((3)*((x22)**(6)))+(9)*((x22)**(5)))-((9)*((x22)**(4)))+(3)*((x22)**(3))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(-((9)*((x12)**(10)))+((((((36)*(x22))-(18)) )*(x11)+-((18)*(x22))+9) )*((x12)**(8))+(((((-((63)*((x22)**(2)))+(129/2)*(x22))-(6)) )*((x11)**(2))+((((63)*((x22)**(2)))-((129/2)*(x22))+6) )*(x11)+-((9)*((x22)**(2)))+(9)*(x22)) )*((x12)**(6))+((((((54)*((x22)**(3)))-((165/2)*((x22)**(2)))+(57/2)*(x22)) )*((x11)**(3))+(((-((165/2)*((x22)**(3)))+(126)*((x22)**(2)))-((87/2)*(x22))) )*((x11)**(2))+((((57/2)*((x22)**(3)))-((87/2)*((x22)**(2)))+(15)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((18)*((x22)**(4)))+(36)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(4))+((((75/2)*((x22)**(4)))-((75)*((x22)**(3)))+(75/2)*((x22)**(2))) )*((x11)**(3))+(((-((57/2)*((x22)**(4)))+(57)*((x22)**(3)))-((57/2)*((x22)**(2)))) )*((x11)**(2))+((((9)*((x22)**(4)))-((18)*((x22)**(3)))+(9)*((x22)**(2))) )*(x11)) )*((x12)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((102)*(x22))+53) )*((x12)**(9))+((((((291)*((x22)**(2)))-((605/2)*(x22))+46) )*(x11)+(-((153)*((x22)**(2)))+(159)*(x22))-(24)) )*((x12)**(7))+(((((-((297)*((x22)**(3)))+(464)*((x22)**(2)))-((359/2)*(x22))+8) )*((x11)**(2))+(((((631/2)*((x22)**(3)))-((492)*((x22)**(2)))+(189)*(x22))-(8)) )*(x11)+(-((90)*((x22)**(3)))+(138)*((x22)**(2)))-((48)*(x22))) )*((x12)**(5))+(((((((129)*((x22)**(4)))-((537/2)*((x22)**(3)))+(339/2)*((x22)**(2)))-((30)*(x22))) )*((x11)**(3))+(((-((208)*((x22)**(4)))+(432)*((x22)**(3)))-((270)*((x22)**(2)))+(46)*(x22)) )*((x11)**(2))+(((((239/2)*((x22)**(4)))-((489/2)*((x22)**(3)))+(141)*((x22)**(2)))-((16)*(x22))) )*(x11)+(-((24)*((x22)**(4)))+(48)*((x22)**(3)))-((24)*((x22)**(2)))) )*((x12)**(3))+(((((-((21)*((x22)**(5)))+(54)*((x22)**(4)))-((45)*((x22)**(3)))+(12)*((x22)**(2))) )*((x11)**(4))+(((((91/2)*((x22)**(5)))-((117)*((x22)**(4)))+(195/2)*((x22)**(3)))-((26)*((x22)**(2)))) )*((x11)**(3))+(((-((77/2)*((x22)**(5)))+(99)*((x22)**(4)))-((165/2)*((x22)**(3)))+(22)*((x22)**(2))) )*((x11)**(2))+(((((14)*((x22)**(5)))-((36)*((x22)**(4)))+(30)*((x22)**(3)))-((8)*((x22)**(2)))) )*(x11)) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((39/2)*(x22))+19/2) )*((x12)**(10))+((((((147/2)*((x22)**(2)))-((147/2)*(x22))+23/2) )*(x11)+(-((75/2)*((x22)**(2)))+(75/2)*(x22))-(6)) )*((x12)**(8))+(((((-((99)*((x22)**(3)))+(150)*((x22)**(2)))-((109/2)*(x22))+2) )*((x11)**(2))+(((((101)*((x22)**(3)))-((153)*((x22)**(2)))+(111/2)*(x22))-(2)) )*(x11)+(-((24)*((x22)**(3)))+(36)*((x22)**(2)))-((12)*(x22))) )*((x12)**(6))+(((((((51)*((x22)**(4)))-((104)*((x22)**(3)))+(61)*((x22)**(2)))-((8)*(x22))) )*((x11)**(3))+(((-((78)*((x22)**(4)))+(159)*((x22)**(3)))-((93)*((x22)**(2)))+(12)*(x22)) )*((x11)**(2))+(((((77/2)*((x22)**(4)))-((78)*((x22)**(3)))+(87/2)*((x22)**(2)))-((4)*(x22))) )*(x11)+(-((6)*((x22)**(4)))+(12)*((x22)**(3)))-((6)*((x22)**(2)))) )*((x12)**(4))+(((((-((3/2)*((x22)**(5)))+(9/2)*((x22)**(4)))-((9/2)*((x22)**(3)))+(3/2)*((x22)**(2))) )*((x11)**(4))+(((((3)*((x22)**(5)))-((9)*((x22)**(4)))+(9)*((x22)**(3)))-((3)*((x22)**(2)))) )*((x11)**(3))+(((-((5)*((x22)**(5)))+(27/2)*((x22)**(4)))-((12)*((x22)**(3)))+(7/2)*((x22)**(2))) )*((x11)**(2))+(((((7/2)*((x22)**(5)))-((9)*((x22)**(4)))+(15/2)*((x22)**(3)))-((2)*((x22)**(2)))) )*(x11)) )*((x12)**(2))+(((-((9/2)*((x22)**(6)))+(27/2)*((x22)**(5)))-((27/2)*((x22)**(4)))+(9/2)*((x22)**(3))) )*((x11)**(5))+(((((23/2)*((x22)**(6)))-((69/2)*((x22)**(5)))+(69/2)*((x22)**(4)))-((23/2)*((x22)**(3)))) )*((x11)**(4))+(((-((19/2)*((x22)**(6)))+(57/2)*((x22)**(5)))-((57/2)*((x22)**(4)))+(19/2)*((x22)**(3))) )*((x11)**(3))+(((((5/2)*((x22)**(6)))-((15/2)*((x22)**(5)))+(15/2)*((x22)**(4)))-((5/2)*((x22)**(3)))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1))]])
  p12=np.array([[0,0,1,0,0,0,0,0],[0,0,0,0,0,1,0,0],[0,0,0,0,0,0,4,0],[0,0,0,0,1,0,0,0],[0,(((6)*((x11)**(2)))-((6)*(x11)))/(d5),0,(-((6)*((x12)**(2))))/(d5),(-((6)*((x12)**(3))))/(d5),(((((6)*((x11)**(2)))-((6)*(x11))) )*(x12))/(d5),(((-((14)*(x11))+8) )*((x12)**(2))+((((14)*(x22))-(8)) )*((x11)**(2))+((-((14)*(x22))+8) )*(x11))/(d5),(((-((4)*(x11))+2) )*((x12)**(3))+((((((4)*(x22))-(2)) )*((x11)**(2))+((-((4)*(x22))+2) )*(x11)) )*(x12))/(d5)],[0,(-((6)*((x12)**(2))))/(d5),0,(((6)*((x22)**(2)))-((6)*(x22)))/(d5),(((((6)*((x22)**(2)))-((6)*(x22))) )*(x12))/(d5),(-((6)*((x12)**(3))))/(d5),(((-((14)*(x22))+8) )*((x12)**(2))+((((14)*((x22)**(2)))-((14)*(x22))) )*(x11)+-((8)*((x22)**(2)))+(8)*(x22))/(d5),(((-((4)*(x22))+2) )*((x12)**(3))+((((((4)*((x22)**(2)))-((4)*(x22))) )*(x11)+-((2)*((x22)**(2)))+(2)*(x22)) )*(x12))/(d5)],[0,0,0,0,0,0,0,1],[((9)*(d5))/((((d4)*(d3))*(d2))*(d1)),(((((-((27)*(x22))+12) )*((x11)**(2))+((((27)*(x22))-(12)) )*(x11)) )*((x12)**(6))+((((((75)*((x22)**(2)))-((75)*(x22))) )*((x11)**(3))+((-((111)*((x22)**(2)))+(111)*(x22)) )*((x11)**(2))+((((36)*((x22)**(2)))-((36)*(x22))) )*(x11)) )*((x12)**(4))+(((((-((69)*((x22)**(3)))+(105)*((x22)**(2)))-((36)*(x22))) )*((x11)**(4))+((((138)*((x22)**(3)))-((210)*((x22)**(2)))+(72)*(x22)) )*((x11)**(3))+(((-((69)*((x22)**(3)))+(105)*((x22)**(2)))-((36)*(x22))) )*((x11)**(2))) )*((x12)**(2))+((((21)*((x22)**(4)))-((42)*((x22)**(3)))+(21)*((x22)**(2))) )*((x11)**(5))+(((-((54)*((x22)**(4)))+(108)*((x22)**(3)))-((54)*((x22)**(2)))) )*((x11)**(4))+((((45)*((x22)**(4)))-((90)*((x22)**(3)))+(45)*((x22)**(2))) )*((x11)**(3))+(((-((12)*((x22)**(4)))+(24)*((x22)**(3)))-((12)*((x22)**(2)))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((27)*(d5))*(x12))/((((d4)*(d3))*(d2))*(d1)),(((((-((27)*((x22)**(2)))+(27)*(x22)) )*(x11)+((12)*((x22)**(2)))-((12)*(x22))) )*((x12)**(6))+((((((75)*((x22)**(3)))-((111)*((x22)**(2)))+(36)*(x22)) )*((x11)**(2))+(((-((75)*((x22)**(3)))+(111)*((x22)**(2)))-((36)*(x22))) )*(x11)) )*((x12)**(4))+(((((-((69)*((x22)**(4)))+(138)*((x22)**(3)))-((69)*((x22)**(2)))) )*((x11)**(3))+((((105)*((x22)**(4)))-((210)*((x22)**(3)))+(105)*((x22)**(2))) )*((x11)**(2))+(((-((36)*((x22)**(4)))+(72)*((x22)**(3)))-((36)*((x22)**(2)))) )*(x11)) )*((x12)**(2))+(((((21)*((x22)**(5)))-((54)*((x22)**(4)))+(45)*((x22)**(3)))-((12)*((x22)**(2)))) )*((x11)**(4))+(((-((42)*((x22)**(5)))+(108)*((x22)**(4)))-((90)*((x22)**(3)))+(24)*((x22)**(2))) )*((x11)**(3))+(((((21)*((x22)**(5)))-((54)*((x22)**(4)))+(45)*((x22)**(3)))-((12)*((x22)**(2)))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((-((15)*((x22)**(2)))+(15)*(x22)) )*(x11)+((6)*((x22)**(2)))-((6)*(x22))) )*((x12)**(7))+((((((63)*((x22)**(3)))-((93)*((x22)**(2)))+(30)*(x22)) )*((x11)**(2))+(((-((63)*((x22)**(3)))+(93)*((x22)**(2)))-((30)*(x22))) )*(x11)) )*((x12)**(5))+(((((-((81)*((x22)**(4)))+(162)*((x22)**(3)))-((81)*((x22)**(2)))) )*((x11)**(3))+((((123)*((x22)**(4)))-((246)*((x22)**(3)))+(123)*((x22)**(2))) )*((x11)**(2))+(((-((42)*((x22)**(4)))+(84)*((x22)**(3)))-((42)*((x22)**(2)))) )*(x11)) )*((x12)**(3))+(((((((33)*((x22)**(5)))-((84)*((x22)**(4)))+(69)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(4))+(((-((66)*((x22)**(5)))+(168)*((x22)**(4)))-((138)*((x22)**(3)))+(36)*((x22)**(2))) )*((x11)**(3))+(((((33)*((x22)**(5)))-((84)*((x22)**(4)))+(69)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((-((15)*(x22))+6) )*((x11)**(2))+((((15)*(x22))-(6)) )*(x11)) )*((x12)**(7))+((((((63)*((x22)**(2)))-((63)*(x22))) )*((x11)**(3))+((-((93)*((x22)**(2)))+(93)*(x22)) )*((x11)**(2))+((((30)*((x22)**(2)))-((30)*(x22))) )*(x11)) )*((x12)**(5))+(((((-((81)*((x22)**(3)))+(123)*((x22)**(2)))-((42)*(x22))) )*((x11)**(4))+((((162)*((x22)**(3)))-((246)*((x22)**(2)))+(84)*(x22)) )*((x11)**(3))+(((-((81)*((x22)**(3)))+(123)*((x22)**(2)))-((42)*(x22))) )*((x11)**(2))) )*((x12)**(3))+((((((33)*((x22)**(4)))-((66)*((x22)**(3)))+(33)*((x22)**(2))) )*((x11)**(5))+(((-((84)*((x22)**(4)))+(168)*((x22)**(3)))-((84)*((x22)**(2)))) )*((x11)**(4))+((((69)*((x22)**(4)))-((138)*((x22)**(3)))+(69)*((x22)**(2))) )*((x11)**(3))+(((-((18)*((x22)**(4)))+(36)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),((74)*((x12)**(10))+((((-((49)*(x22))+28) )*(x11)+((28)*(x22))-(16)) )*((x12)**(8))+(((((-((274)*((x22)**(2)))+(275)*(x22))-(16)) )*((x11)**(2))+((((275)*((x22)**(2)))-((276)*(x22))+16) )*(x11)+-((16)*((x22)**(2)))+(16)*(x22)) )*((x12)**(6))+((((((448)*((x22)**(3)))-((688)*((x22)**(2)))+(240)*(x22)) )*((x11)**(3))+(((-((688)*((x22)**(3)))+(1056)*((x22)**(2)))-((368)*(x22))) )*((x11)**(2))+((((240)*((x22)**(3)))-((368)*((x22)**(2)))+(128)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((248)*((x22)**(4)))+(511)*((x22)**(3)))-((311)*((x22)**(2)))+(48)*(x22)) )*((x11)**(4))+(((((511)*((x22)**(4)))-((1052)*((x22)**(3)))+(637)*((x22)**(2)))-((96)*(x22))) )*((x11)**(3))+(((-((311)*((x22)**(4)))+(637)*((x22)**(3)))-((374)*((x22)**(2)))+(48)*(x22)) )*((x11)**(2))+((((48)*((x22)**(4)))-((96)*((x22)**(3)))+(48)*((x22)**(2))) )*(x11)) )*((x12)**(2))+(((((49)*((x22)**(5)))-((126)*((x22)**(4)))+(105)*((x22)**(3)))-((28)*((x22)**(2)))) )*((x11)**(5))+(((-((126)*((x22)**(5)))+(324)*((x22)**(4)))-((270)*((x22)**(3)))+(72)*((x22)**(2))) )*((x11)**(4))+(((((105)*((x22)**(5)))-((270)*((x22)**(4)))+(225)*((x22)**(3)))-((60)*((x22)**(2)))) )*((x11)**(3))+(((-((28)*((x22)**(5)))+(72)*((x22)**(4)))-((60)*((x22)**(3)))+(16)*((x22)**(2))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),((16)*((x12)**(11))+((((-((32)*(x22))+17) )*(x11)+((17)*(x22))-(9)) )*((x12)**(9))+((((-((32)*((x22)**(2)))+(30)*(x22)+1) )*((x11)**(2))+(((((30)*((x22)**(2)))-((28)*(x22)))-(1)) )*(x11)+((x22)**(2))-(x22)) )*((x12)**(7))+((((((128)*((x22)**(3)))-((192)*((x22)**(2)))+(64)*(x22)) )*((x11)**(3))+(((-((192)*((x22)**(3)))+(288)*((x22)**(2)))-((96)*(x22))) )*((x11)**(2))+((((64)*((x22)**(3)))-((96)*((x22)**(2)))+(32)*(x22)) )*(x11)) )*((x12)**(5))+(((((-((112)*((x22)**(4)))+(226)*((x22)**(3)))-((131)*((x22)**(2)))+(17)*(x22)) )*((x11)**(4))+(((((226)*((x22)**(4)))-((456)*((x22)**(3)))+(264)*((x22)**(2)))-((34)*(x22))) )*((x11)**(3))+(((-((131)*((x22)**(4)))+(264)*((x22)**(3)))-((150)*((x22)**(2)))+(17)*(x22)) )*((x11)**(2))+((((17)*((x22)**(4)))-((34)*((x22)**(3)))+(17)*((x22)**(2))) )*(x11)) )*((x12)**(3))+(((((((32)*((x22)**(5)))-((81)*((x22)**(4)))+(66)*((x22)**(3)))-((17)*((x22)**(2)))) )*((x11)**(5))+(((-((81)*((x22)**(5)))+(205)*((x22)**(4)))-((167)*((x22)**(3)))+(43)*((x22)**(2))) )*((x11)**(4))+(((((66)*((x22)**(5)))-((167)*((x22)**(4)))+(136)*((x22)**(3)))-((35)*((x22)**(2)))) )*((x11)**(3))+(((-((17)*((x22)**(5)))+(43)*((x22)**(4)))-((35)*((x22)**(3)))+(9)*((x22)**(2))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1))]])
  p22=np.array([[0,0,0,1,0,0,0,0],[0,0,0,0,0,0,1,0],[0,0,0,0,1,0,0,0],[(-3/2)/(((x22)**(2))-(x22)),0,(-((3/2)*(x12)))/(((x22)**(2))-(x22)),(-((7/2)*(x22))+2)/(((x22)**(2))-(x22)),(((-(x22)+1/2) )*(x12))/(((x22)**(2))-(x22)),0,(-((x12)**(2)))/(((x22)**(2))-(x22)),0],[0,(((((-((6)*(x22))+3) )*((x11)**(2))+((((6)*(x22))-(3)) )*(x11)) )*(x12))/(((d5)*((x22)**(2)))-((d5)*(x22))),(-3)/(((x22)**(2))-(x22)),(((((6)*(x22))-(3)) )*((x12)**(3)))/(((d5)*((x22)**(2)))-((d5)*(x22))),(((((3/2)*(x22))-(1/2)) )*((x12)**(4))+((((9/2)*((x22)**(3)))-((7)*((x22)**(2)))+(5/2)*(x22)) )*((x11)**(2))+(((-((9/2)*((x22)**(3)))+(7)*((x22)**(2)))-((5/2)*(x22))) )*(x11))/(((d5)*((x22)**(2)))-((d5)*(x22))),(((((-((6)*(x22))+3) )*((x11)**(2))+((((6)*(x22))-(3)) )*(x11)) )*((x12)**(2)))/(((d5)*((x22)**(2)))-((d5)*(x22))),(-((8)*((x12)**(5)))+((((((14)*(x22))-(7)) )*(x11)+-((8)*(x22))+4) )*((x12)**(3))+(((((-((6)*((x22)**(2)))+(7)*(x22))-(4)) )*((x11)**(2))+((((6)*((x22)**(2)))-((7)*(x22))+4) )*(x11)) )*(x12))/(((d5)*((x22)**(2)))-((d5)*(x22))),(-((x12)**(6))+((((((4)*(x22))-(2)) )*(x11)+-((2)*(x22))+1) )*((x12)**(4))+(((((-((3)*((x22)**(2)))+(3)*(x22))-(1)) )*((x11)**(2))+((((3)*((x22)**(2)))-((3)*(x22))+1) )*(x11)) )*((x12)**(2)))/(((d5)*((x22)**(2)))-((d5)*(x22)))],[0,0,0,0,0,0,0,1],[0,(((3/2)*((x11)**(2)))-((3/2)*(x11)))/(d5),0,(-((3/2)*((x12)**(2))))/(d5),(-((3/2)*((x12)**(3))))/(d5),(((((3/2)*((x11)**(2)))-((3/2)*(x11))) )*(x12))/(d5),(((-((7/2)*(x11))+2) )*((x12)**(2))+((((7/2)*(x22))-(2)) )*((x11)**(2))+((-((7/2)*(x22))+2) )*(x11))/(d5),(((-(x11)+1/2) )*((x12)**(3))+(((((x22)-(1/2)) )*((x11)**(2))+((-(x22)+1/2) )*(x11)) )*(x12))/(d5)],[(((-((9)*(x11))+9/2) )*((x12)**(3))+((((((9)*(x22))-(9/2)) )*((x11)**(2))+((-((9)*(x22))+9/2) )*(x11)) )*(x12))/((((d4)*(d3))*(d2))*(d1)),(((((24)*((x11)**(2)))-((24)*(x11))) )*((x12)**(7))+((((-((69)*(x22))+36) )*((x11)**(3))+((((207/2)*(x22))-(54)) )*((x11)**(2))+((-((69/2)*(x22))+18) )*(x11)) )*((x12)**(5))+((((((66)*((x22)**(2)))-((135/2)*(x22))+18) )*((x11)**(4))+(((-((267/2)*((x22)**(2)))+(273/2)*(x22))-(36)) )*((x11)**(3))+((((147/2)*((x22)**(2)))-((75)*(x22))+18) )*((x11)**(2))+((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)) )*((x12)**(3))+(((((-((21)*((x22)**(3)))+(63/2)*((x22)**(2)))-((21/2)*(x22))) )*((x11)**(5))+((((54)*((x22)**(3)))-((81)*((x22)**(2)))+(27)*(x22)) )*((x11)**(4))+(((-((45)*((x22)**(3)))+(135/2)*((x22)**(2)))-((45/2)*(x22))) )*((x11)**(3))+((((12)*((x22)**(3)))-((18)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((27)*(x11))+27/2) )*((x12)**(4))+((((((27)*(x22))-(27/2)) )*((x11)**(2))+((-((27)*(x22))+27/2) )*(x11)) )*((x12)**(2)))/((((d4)*(d3))*(d2))*(d1)),(-((12)*((x12)**(9)))+((((((48)*(x22))-(24)) )*(x11)+-((24)*(x22))+12) )*((x12)**(7))+(((((-((69)*((x22)**(2)))+(69)*(x22))-(12)) )*((x11)**(2))+((((141/2)*((x22)**(2)))-((141/2)*(x22))+12) )*(x11)+-((6)*((x22)**(2)))+(6)*(x22)) )*((x12)**(5))+((((((42)*((x22)**(3)))-((129/2)*((x22)**(2)))+(45/2)*(x22)) )*((x11)**(3))+(((-((129/2)*((x22)**(3)))+(99)*((x22)**(2)))-((69/2)*(x22))) )*((x11)**(2))+((((45/2)*((x22)**(3)))-((69/2)*((x22)**(2)))+(12)*(x22)) )*(x11)) )*((x12)**(3))+(((((-((9)*((x22)**(4)))+(39/2)*((x22)**(3)))-((33/2)*((x22)**(2)))+(6)*(x22)) )*((x11)**(4))+(((((18)*((x22)**(4)))-((39)*((x22)**(3)))+(33)*((x22)**(2)))-((12)*(x22))) )*((x11)**(3))+(((-((9)*((x22)**(4)))+(39/2)*((x22)**(3)))-((33/2)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(-((9)*((x12)**(10)))+((((((36)*(x22))-(18)) )*(x11)+-((18)*(x22))+9) )*((x12)**(8))+(((((-((63)*((x22)**(2)))+(63)*(x22))-(9)) )*((x11)**(2))+((((129/2)*((x22)**(2)))-((129/2)*(x22))+9) )*(x11)+-((6)*((x22)**(2)))+(6)*(x22)) )*((x12)**(6))+((((((54)*((x22)**(3)))-((165/2)*((x22)**(2)))+(57/2)*(x22)) )*((x11)**(3))+(((-((165/2)*((x22)**(3)))+(126)*((x22)**(2)))-((87/2)*(x22))) )*((x11)**(2))+((((57/2)*((x22)**(3)))-((87/2)*((x22)**(2)))+(15)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((18)*((x22)**(4)))+(75/2)*((x22)**(3)))-((57/2)*((x22)**(2)))+(9)*(x22)) )*((x11)**(4))+(((((36)*((x22)**(4)))-((75)*((x22)**(3)))+(57)*((x22)**(2)))-((18)*(x22))) )*((x11)**(3))+(((-((18)*((x22)**(4)))+(75/2)*((x22)**(3)))-((57/2)*((x22)**(2)))+(9)*(x22)) )*((x11)**(2))) )*((x12)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((21)*((x11)**(2)))-((21)*(x11))) )*((x12)**(8))+((((-((69)*(x22))+36) )*((x11)**(3))+((((207/2)*(x22))-(54)) )*((x11)**(2))+((-((69/2)*(x22))+18) )*(x11)) )*((x12)**(6))+((((((72)*((x22)**(2)))-((147/2)*(x22))+18) )*((x11)**(4))+(((-((291/2)*((x22)**(2)))+(297/2)*(x22))-(36)) )*((x11)**(3))+((((159/2)*((x22)**(2)))-((81)*(x22))+18) )*((x11)**(2))+((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((21)*((x22)**(3)))+(63/2)*((x22)**(2)))-((21/2)*(x22))) )*((x11)**(5))+((((54)*((x22)**(3)))-((81)*((x22)**(2)))+(27)*(x22)) )*((x11)**(4))+(((-((45)*((x22)**(3)))+(135/2)*((x22)**(2)))-((45/2)*(x22))) )*((x11)**(3))+((((12)*((x22)**(3)))-((18)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))) )*((x12)**(2))+(((-((3)*((x22)**(4)))+(6)*((x22)**(3)))-((3)*((x22)**(2)))) )*((x11)**(6))+((((9)*((x22)**(4)))-((18)*((x22)**(3)))+(9)*((x22)**(2))) )*((x11)**(5))+(((-((9)*((x22)**(4)))+(18)*((x22)**(3)))-((9)*((x22)**(2)))) )*((x11)**(4))+((((3)*((x22)**(4)))-((6)*((x22)**(3)))+(3)*((x22)**(2))) )*((x11)**(3)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((102)*(x11))+53) )*((x12)**(9))+((((((291)*(x22))-(153)) )*((x11)**(2))+((-((605/2)*(x22))+159) )*(x11)+((46)*(x22))-(24)) )*((x12)**(7))+(((((-((297)*((x22)**(2)))+(631/2)*(x22))-(90)) )*((x11)**(3))+((((464)*((x22)**(2)))-((492)*(x22))+138) )*((x11)**(2))+(((-((359/2)*((x22)**(2)))+(189)*(x22))-(48)) )*(x11)+((8)*((x22)**(2)))-((8)*(x22))) )*((x12)**(5))+(((((((129)*((x22)**(3)))-((208)*((x22)**(2)))+(239/2)*(x22))-(24)) )*((x11)**(4))+(((-((537/2)*((x22)**(3)))+(432)*((x22)**(2)))-((489/2)*(x22))+48) )*((x11)**(3))+(((((339/2)*((x22)**(3)))-((270)*((x22)**(2)))+(141)*(x22))-(24)) )*((x11)**(2))+(((-((30)*((x22)**(3)))+(46)*((x22)**(2)))-((16)*(x22))) )*(x11)) )*((x12)**(3))+(((((-((21)*((x22)**(4)))+(91/2)*((x22)**(3)))-((77/2)*((x22)**(2)))+(14)*(x22)) )*((x11)**(5))+(((((54)*((x22)**(4)))-((117)*((x22)**(3)))+(99)*((x22)**(2)))-((36)*(x22))) )*((x11)**(4))+(((-((45)*((x22)**(4)))+(195/2)*((x22)**(3)))-((165/2)*((x22)**(2)))+(30)*(x22)) )*((x11)**(3))+(((((12)*((x22)**(4)))-((26)*((x22)**(3)))+(22)*((x22)**(2)))-((8)*(x22))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((39/2)*(x11))+19/2) )*((x12)**(10))+((((((147/2)*(x22))-(75/2)) )*((x11)**(2))+((-((147/2)*(x22))+75/2) )*(x11)+((23/2)*(x22))-(6)) )*((x12)**(8))+(((((-((99)*((x22)**(2)))+(101)*(x22))-(24)) )*((x11)**(3))+((((150)*((x22)**(2)))-((153)*(x22))+36) )*((x11)**(2))+(((-((109/2)*((x22)**(2)))+(111/2)*(x22))-(12)) )*(x11)+((2)*((x22)**(2)))-((2)*(x22))) )*((x12)**(6))+(((((((51)*((x22)**(3)))-((78)*((x22)**(2)))+(77/2)*(x22))-(6)) )*((x11)**(4))+(((-((104)*((x22)**(3)))+(159)*((x22)**(2)))-((78)*(x22))+12) )*((x11)**(3))+(((((61)*((x22)**(3)))-((93)*((x22)**(2)))+(87/2)*(x22))-(6)) )*((x11)**(2))+(((-((8)*((x22)**(3)))+(12)*((x22)**(2)))-((4)*(x22))) )*(x11)) )*((x12)**(4))+(((((-((3/2)*((x22)**(4)))+(3)*((x22)**(3)))-((5)*((x22)**(2)))+(7/2)*(x22)) )*((x11)**(5))+(((((9/2)*((x22)**(4)))-((9)*((x22)**(3)))+(27/2)*((x22)**(2)))-((9)*(x22))) )*((x11)**(4))+(((-((9/2)*((x22)**(4)))+(9)*((x22)**(3)))-((12)*((x22)**(2)))+(15/2)*(x22)) )*((x11)**(3))+(((((3/2)*((x22)**(4)))-((3)*((x22)**(3)))+(7/2)*((x22)**(2)))-((2)*(x22))) )*((x11)**(2))) )*((x12)**(2))+(((-((9/2)*((x22)**(5)))+(23/2)*((x22)**(4)))-((19/2)*((x22)**(3)))+(5/2)*((x22)**(2))) )*((x11)**(6))+(((((27/2)*((x22)**(5)))-((69/2)*((x22)**(4)))+(57/2)*((x22)**(3)))-((15/2)*((x22)**(2)))) )*((x11)**(5))+(((-((27/2)*((x22)**(5)))+(69/2)*((x22)**(4)))-((57/2)*((x22)**(3)))+(15/2)*((x22)**(2))) )*((x11)**(4))+(((((9/2)*((x22)**(5)))-((23/2)*((x22)**(4)))+(19/2)*((x22)**(3)))-((5/2)*((x22)**(2)))) )*((x11)**(3)))/(((((d5)*(d4))*(d3))*(d2))*(d1))]])
#------
  p=p11*dx[0]+p12*dx[1]+p22*dx[2]
  return p@f

def f_erf2(t,f,x_1,x_2,x_3,x0_1,x0_2,x0_3):
  global N_calls
  N_calls = N_calls+1
  x = np.array([x_1,x_2,x_3])
  x0 = np.array([x0_1,x0_2,x0_3])
  dx=x-x0
  [x11,x12,x22]=x0+dx*t

#------ from tmp_pf_erf.py
  d1=-((x12)**(2))+(x22)*(x11)
  d2=(x12)**(2)+-((x22)*(x11))+x22
  d3=(x12)**(2)+((-(x22)+1) )*(x11)
  d4=(x12)**(2)+((-(x22)+1) )*(x11)+(x22)-(1)
  d5=(x12)**(4)+((-((x22)**(2))+x22) )*((x11)**(2))+((((x22)**(2))-(x22)) )*(x11)
  p11=np.array([[0,1,0,0,0,0,0,0],[(-3/2)/(((x11)**(2))-(x11)),(-((7/2)*(x11))+2)/(((x11)**(2))-(x11)),(-((3/2)*(x12)))/(((x11)**(2))-(x11)),0,0,(((-(x11)+1/2) )*(x12))/(((x11)**(2))-(x11)),(-((x12)**(2)))/(((x11)**(2))-(x11)),0],[0,0,0,0,0,1,0,0],[0,0,0,0,0,0,1,0],[0,0,0,0,0,0,0,1],[0,(((((6)*(x11))-(3)) )*((x12)**(3)))/(((d5)*((x11)**(2)))-((d5)*(x11))),(-3)/(((x11)**(2))-(x11)),(((((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)+((3)*((x22)**(2)))-((3)*(x22))) )*(x12))/(((d5)*((x11)**(2)))-((d5)*(x11))),(((((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)+((3)*((x22)**(2)))-((3)*(x22))) )*((x12)**(2)))/(((d5)*((x11)**(2)))-((d5)*(x11))),(((((3/2)*(x11))-(1/2)) )*((x12)**(4))+((((9/2)*((x22)**(2)))-((9/2)*(x22))) )*((x11)**(3))+((-((7)*((x22)**(2)))+(7)*(x22)) )*((x11)**(2))+((((5/2)*((x22)**(2)))-((5/2)*(x22))) )*(x11))/(((d5)*((x11)**(2)))-((d5)*(x11))),(-((8)*((x12)**(5)))+((((((14)*(x22))-(8)) )*(x11)+-((7)*(x22))+4) )*((x12)**(3))+((((-((6)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))+((((7)*((x22)**(2)))-((7)*(x22))) )*(x11)+-((4)*((x22)**(2)))+(4)*(x22)) )*(x12))/(((d5)*((x11)**(2)))-((d5)*(x11))),(-((x12)**(6))+((((((4)*(x22))-(2)) )*(x11)+-((2)*(x22))+1) )*((x12)**(4))+((((-((3)*((x22)**(2)))+(3)*(x22)) )*((x11)**(2))+((((3)*((x22)**(2)))-((3)*(x22))) )*(x11)+-((x22)**(2))+x22) )*((x12)**(2)))/(((d5)*((x11)**(2)))-((d5)*(x11)))],[0,(-((3/2)*((x12)**(2))))/(d5),0,(((3/2)*((x22)**(2)))-((3/2)*(x22)))/(d5),(((((3/2)*((x22)**(2)))-((3/2)*(x22))) )*(x12))/(d5),(-((3/2)*((x12)**(3))))/(d5),(((-((7/2)*(x22))+2) )*((x12)**(2))+((((7/2)*((x22)**(2)))-((7/2)*(x22))) )*(x11)+-((2)*((x22)**(2)))+(2)*(x22))/(d5),(((-(x22)+1/2) )*((x12)**(3))+((((((x22)**(2))-(x22)) )*(x11)+-((1/2)*((x22)**(2)))+(1/2)*(x22)) )*(x12))/(d5)],[(((-((9)*(x22))+9/2) )*((x12)**(3))+((((((9)*((x22)**(2)))-((9)*(x22))) )*(x11)+-((9/2)*((x22)**(2)))+(9/2)*(x22)) )*(x12))/((((d4)*(d3))*(d2))*(d1)),(-((12)*((x12)**(9)))+((((((48)*(x22))-(24)) )*(x11)+-((24)*(x22))+12) )*((x12)**(7))+(((((-((69)*((x22)**(2)))+(141/2)*(x22))-(6)) )*((x11)**(2))+((((69)*((x22)**(2)))-((141/2)*(x22))+6) )*(x11)+-((12)*((x22)**(2)))+(12)*(x22)) )*((x12)**(5))+((((((42)*((x22)**(3)))-((129/2)*((x22)**(2)))+(45/2)*(x22)) )*((x11)**(3))+(((-((129/2)*((x22)**(3)))+(99)*((x22)**(2)))-((69/2)*(x22))) )*((x11)**(2))+((((45/2)*((x22)**(3)))-((69/2)*((x22)**(2)))+(12)*(x22)) )*(x11)) )*((x12)**(3))+(((((-((9)*((x22)**(4)))+(18)*((x22)**(3)))-((9)*((x22)**(2)))) )*((x11)**(4))+((((39/2)*((x22)**(4)))-((39)*((x22)**(3)))+(39/2)*((x22)**(2))) )*((x11)**(3))+(((-((33/2)*((x22)**(4)))+(33)*((x22)**(3)))-((33/2)*((x22)**(2)))) )*((x11)**(2))+((((6)*((x22)**(4)))-((12)*((x22)**(3)))+(6)*((x22)**(2))) )*(x11)) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((27)*(x22))+27/2) )*((x12)**(4))+((((((27)*((x22)**(2)))-((27)*(x22))) )*(x11)+-((27/2)*((x22)**(2)))+(27/2)*(x22)) )*((x12)**(2)))/((((d4)*(d3))*(d2))*(d1)),(((((24)*((x22)**(2)))-((24)*(x22))) )*((x12)**(7))+(((((-((69)*((x22)**(3)))+(207/2)*((x22)**(2)))-((69/2)*(x22))) )*(x11)+((36)*((x22)**(3)))-((54)*((x22)**(2)))+(18)*(x22)) )*((x12)**(5))+(((((((66)*((x22)**(4)))-((267/2)*((x22)**(3)))+(147/2)*((x22)**(2)))-((6)*(x22))) )*((x11)**(2))+(((-((135/2)*((x22)**(4)))+(273/2)*((x22)**(3)))-((75)*((x22)**(2)))+(6)*(x22)) )*(x11)+((18)*((x22)**(4)))-((36)*((x22)**(3)))+(18)*((x22)**(2))) )*((x12)**(3))+(((((-((21)*((x22)**(5)))+(54)*((x22)**(4)))-((45)*((x22)**(3)))+(12)*((x22)**(2))) )*((x11)**(3))+(((((63/2)*((x22)**(5)))-((81)*((x22)**(4)))+(135/2)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))+(((-((21/2)*((x22)**(5)))+(27)*((x22)**(4)))-((45/2)*((x22)**(3)))+(6)*((x22)**(2))) )*(x11)) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((21)*((x22)**(2)))-((21)*(x22))) )*((x12)**(8))+(((((-((69)*((x22)**(3)))+(207/2)*((x22)**(2)))-((69/2)*(x22))) )*(x11)+((36)*((x22)**(3)))-((54)*((x22)**(2)))+(18)*(x22)) )*((x12)**(6))+(((((((72)*((x22)**(4)))-((291/2)*((x22)**(3)))+(159/2)*((x22)**(2)))-((6)*(x22))) )*((x11)**(2))+(((-((147/2)*((x22)**(4)))+(297/2)*((x22)**(3)))-((81)*((x22)**(2)))+(6)*(x22)) )*(x11)+((18)*((x22)**(4)))-((36)*((x22)**(3)))+(18)*((x22)**(2))) )*((x12)**(4))+(((((-((21)*((x22)**(5)))+(54)*((x22)**(4)))-((45)*((x22)**(3)))+(12)*((x22)**(2))) )*((x11)**(3))+(((((63/2)*((x22)**(5)))-((81)*((x22)**(4)))+(135/2)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))+(((-((21/2)*((x22)**(5)))+(27)*((x22)**(4)))-((45/2)*((x22)**(3)))+(6)*((x22)**(2))) )*(x11)) )*((x12)**(2))+(((-((3)*((x22)**(6)))+(9)*((x22)**(5)))-((9)*((x22)**(4)))+(3)*((x22)**(3))) )*((x11)**(4))+(((((6)*((x22)**(6)))-((18)*((x22)**(5)))+(18)*((x22)**(4)))-((6)*((x22)**(3)))) )*((x11)**(3))+(((-((3)*((x22)**(6)))+(9)*((x22)**(5)))-((9)*((x22)**(4)))+(3)*((x22)**(3))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(-((9)*((x12)**(10)))+((((((36)*(x22))-(18)) )*(x11)+-((18)*(x22))+9) )*((x12)**(8))+(((((-((63)*((x22)**(2)))+(129/2)*(x22))-(6)) )*((x11)**(2))+((((63)*((x22)**(2)))-((129/2)*(x22))+6) )*(x11)+-((9)*((x22)**(2)))+(9)*(x22)) )*((x12)**(6))+((((((54)*((x22)**(3)))-((165/2)*((x22)**(2)))+(57/2)*(x22)) )*((x11)**(3))+(((-((165/2)*((x22)**(3)))+(126)*((x22)**(2)))-((87/2)*(x22))) )*((x11)**(2))+((((57/2)*((x22)**(3)))-((87/2)*((x22)**(2)))+(15)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((18)*((x22)**(4)))+(36)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(4))+((((75/2)*((x22)**(4)))-((75)*((x22)**(3)))+(75/2)*((x22)**(2))) )*((x11)**(3))+(((-((57/2)*((x22)**(4)))+(57)*((x22)**(3)))-((57/2)*((x22)**(2)))) )*((x11)**(2))+((((9)*((x22)**(4)))-((18)*((x22)**(3)))+(9)*((x22)**(2))) )*(x11)) )*((x12)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((102)*(x22))+53) )*((x12)**(9))+((((((291)*((x22)**(2)))-((605/2)*(x22))+46) )*(x11)+(-((153)*((x22)**(2)))+(159)*(x22))-(24)) )*((x12)**(7))+(((((-((297)*((x22)**(3)))+(464)*((x22)**(2)))-((359/2)*(x22))+8) )*((x11)**(2))+(((((631/2)*((x22)**(3)))-((492)*((x22)**(2)))+(189)*(x22))-(8)) )*(x11)+(-((90)*((x22)**(3)))+(138)*((x22)**(2)))-((48)*(x22))) )*((x12)**(5))+(((((((129)*((x22)**(4)))-((537/2)*((x22)**(3)))+(339/2)*((x22)**(2)))-((30)*(x22))) )*((x11)**(3))+(((-((208)*((x22)**(4)))+(432)*((x22)**(3)))-((270)*((x22)**(2)))+(46)*(x22)) )*((x11)**(2))+(((((239/2)*((x22)**(4)))-((489/2)*((x22)**(3)))+(141)*((x22)**(2)))-((16)*(x22))) )*(x11)+(-((24)*((x22)**(4)))+(48)*((x22)**(3)))-((24)*((x22)**(2)))) )*((x12)**(3))+(((((-((21)*((x22)**(5)))+(54)*((x22)**(4)))-((45)*((x22)**(3)))+(12)*((x22)**(2))) )*((x11)**(4))+(((((91/2)*((x22)**(5)))-((117)*((x22)**(4)))+(195/2)*((x22)**(3)))-((26)*((x22)**(2)))) )*((x11)**(3))+(((-((77/2)*((x22)**(5)))+(99)*((x22)**(4)))-((165/2)*((x22)**(3)))+(22)*((x22)**(2))) )*((x11)**(2))+(((((14)*((x22)**(5)))-((36)*((x22)**(4)))+(30)*((x22)**(3)))-((8)*((x22)**(2)))) )*(x11)) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((39/2)*(x22))+19/2) )*((x12)**(10))+((((((147/2)*((x22)**(2)))-((147/2)*(x22))+23/2) )*(x11)+(-((75/2)*((x22)**(2)))+(75/2)*(x22))-(6)) )*((x12)**(8))+(((((-((99)*((x22)**(3)))+(150)*((x22)**(2)))-((109/2)*(x22))+2) )*((x11)**(2))+(((((101)*((x22)**(3)))-((153)*((x22)**(2)))+(111/2)*(x22))-(2)) )*(x11)+(-((24)*((x22)**(3)))+(36)*((x22)**(2)))-((12)*(x22))) )*((x12)**(6))+(((((((51)*((x22)**(4)))-((104)*((x22)**(3)))+(61)*((x22)**(2)))-((8)*(x22))) )*((x11)**(3))+(((-((78)*((x22)**(4)))+(159)*((x22)**(3)))-((93)*((x22)**(2)))+(12)*(x22)) )*((x11)**(2))+(((((77/2)*((x22)**(4)))-((78)*((x22)**(3)))+(87/2)*((x22)**(2)))-((4)*(x22))) )*(x11)+(-((6)*((x22)**(4)))+(12)*((x22)**(3)))-((6)*((x22)**(2)))) )*((x12)**(4))+(((((-((3/2)*((x22)**(5)))+(9/2)*((x22)**(4)))-((9/2)*((x22)**(3)))+(3/2)*((x22)**(2))) )*((x11)**(4))+(((((3)*((x22)**(5)))-((9)*((x22)**(4)))+(9)*((x22)**(3)))-((3)*((x22)**(2)))) )*((x11)**(3))+(((-((5)*((x22)**(5)))+(27/2)*((x22)**(4)))-((12)*((x22)**(3)))+(7/2)*((x22)**(2))) )*((x11)**(2))+(((((7/2)*((x22)**(5)))-((9)*((x22)**(4)))+(15/2)*((x22)**(3)))-((2)*((x22)**(2)))) )*(x11)) )*((x12)**(2))+(((-((9/2)*((x22)**(6)))+(27/2)*((x22)**(5)))-((27/2)*((x22)**(4)))+(9/2)*((x22)**(3))) )*((x11)**(5))+(((((23/2)*((x22)**(6)))-((69/2)*((x22)**(5)))+(69/2)*((x22)**(4)))-((23/2)*((x22)**(3)))) )*((x11)**(4))+(((-((19/2)*((x22)**(6)))+(57/2)*((x22)**(5)))-((57/2)*((x22)**(4)))+(19/2)*((x22)**(3))) )*((x11)**(3))+(((((5/2)*((x22)**(6)))-((15/2)*((x22)**(5)))+(15/2)*((x22)**(4)))-((5/2)*((x22)**(3)))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1))]])
  p12=np.array([[0,0,1,0,0,0,0,0],[0,0,0,0,0,1,0,0],[0,0,0,0,0,0,4,0],[0,0,0,0,1,0,0,0],[0,(((6)*((x11)**(2)))-((6)*(x11)))/(d5),0,(-((6)*((x12)**(2))))/(d5),(-((6)*((x12)**(3))))/(d5),(((((6)*((x11)**(2)))-((6)*(x11))) )*(x12))/(d5),(((-((14)*(x11))+8) )*((x12)**(2))+((((14)*(x22))-(8)) )*((x11)**(2))+((-((14)*(x22))+8) )*(x11))/(d5),(((-((4)*(x11))+2) )*((x12)**(3))+((((((4)*(x22))-(2)) )*((x11)**(2))+((-((4)*(x22))+2) )*(x11)) )*(x12))/(d5)],[0,(-((6)*((x12)**(2))))/(d5),0,(((6)*((x22)**(2)))-((6)*(x22)))/(d5),(((((6)*((x22)**(2)))-((6)*(x22))) )*(x12))/(d5),(-((6)*((x12)**(3))))/(d5),(((-((14)*(x22))+8) )*((x12)**(2))+((((14)*((x22)**(2)))-((14)*(x22))) )*(x11)+-((8)*((x22)**(2)))+(8)*(x22))/(d5),(((-((4)*(x22))+2) )*((x12)**(3))+((((((4)*((x22)**(2)))-((4)*(x22))) )*(x11)+-((2)*((x22)**(2)))+(2)*(x22)) )*(x12))/(d5)],[0,0,0,0,0,0,0,1],[((9)*(d5))/((((d4)*(d3))*(d2))*(d1)),(((((-((27)*(x22))+12) )*((x11)**(2))+((((27)*(x22))-(12)) )*(x11)) )*((x12)**(6))+((((((75)*((x22)**(2)))-((75)*(x22))) )*((x11)**(3))+((-((111)*((x22)**(2)))+(111)*(x22)) )*((x11)**(2))+((((36)*((x22)**(2)))-((36)*(x22))) )*(x11)) )*((x12)**(4))+(((((-((69)*((x22)**(3)))+(105)*((x22)**(2)))-((36)*(x22))) )*((x11)**(4))+((((138)*((x22)**(3)))-((210)*((x22)**(2)))+(72)*(x22)) )*((x11)**(3))+(((-((69)*((x22)**(3)))+(105)*((x22)**(2)))-((36)*(x22))) )*((x11)**(2))) )*((x12)**(2))+((((21)*((x22)**(4)))-((42)*((x22)**(3)))+(21)*((x22)**(2))) )*((x11)**(5))+(((-((54)*((x22)**(4)))+(108)*((x22)**(3)))-((54)*((x22)**(2)))) )*((x11)**(4))+((((45)*((x22)**(4)))-((90)*((x22)**(3)))+(45)*((x22)**(2))) )*((x11)**(3))+(((-((12)*((x22)**(4)))+(24)*((x22)**(3)))-((12)*((x22)**(2)))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((27)*(d5))*(x12))/((((d4)*(d3))*(d2))*(d1)),(((((-((27)*((x22)**(2)))+(27)*(x22)) )*(x11)+((12)*((x22)**(2)))-((12)*(x22))) )*((x12)**(6))+((((((75)*((x22)**(3)))-((111)*((x22)**(2)))+(36)*(x22)) )*((x11)**(2))+(((-((75)*((x22)**(3)))+(111)*((x22)**(2)))-((36)*(x22))) )*(x11)) )*((x12)**(4))+(((((-((69)*((x22)**(4)))+(138)*((x22)**(3)))-((69)*((x22)**(2)))) )*((x11)**(3))+((((105)*((x22)**(4)))-((210)*((x22)**(3)))+(105)*((x22)**(2))) )*((x11)**(2))+(((-((36)*((x22)**(4)))+(72)*((x22)**(3)))-((36)*((x22)**(2)))) )*(x11)) )*((x12)**(2))+(((((21)*((x22)**(5)))-((54)*((x22)**(4)))+(45)*((x22)**(3)))-((12)*((x22)**(2)))) )*((x11)**(4))+(((-((42)*((x22)**(5)))+(108)*((x22)**(4)))-((90)*((x22)**(3)))+(24)*((x22)**(2))) )*((x11)**(3))+(((((21)*((x22)**(5)))-((54)*((x22)**(4)))+(45)*((x22)**(3)))-((12)*((x22)**(2)))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((-((15)*((x22)**(2)))+(15)*(x22)) )*(x11)+((6)*((x22)**(2)))-((6)*(x22))) )*((x12)**(7))+((((((63)*((x22)**(3)))-((93)*((x22)**(2)))+(30)*(x22)) )*((x11)**(2))+(((-((63)*((x22)**(3)))+(93)*((x22)**(2)))-((30)*(x22))) )*(x11)) )*((x12)**(5))+(((((-((81)*((x22)**(4)))+(162)*((x22)**(3)))-((81)*((x22)**(2)))) )*((x11)**(3))+((((123)*((x22)**(4)))-((246)*((x22)**(3)))+(123)*((x22)**(2))) )*((x11)**(2))+(((-((42)*((x22)**(4)))+(84)*((x22)**(3)))-((42)*((x22)**(2)))) )*(x11)) )*((x12)**(3))+(((((((33)*((x22)**(5)))-((84)*((x22)**(4)))+(69)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(4))+(((-((66)*((x22)**(5)))+(168)*((x22)**(4)))-((138)*((x22)**(3)))+(36)*((x22)**(2))) )*((x11)**(3))+(((((33)*((x22)**(5)))-((84)*((x22)**(4)))+(69)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((-((15)*(x22))+6) )*((x11)**(2))+((((15)*(x22))-(6)) )*(x11)) )*((x12)**(7))+((((((63)*((x22)**(2)))-((63)*(x22))) )*((x11)**(3))+((-((93)*((x22)**(2)))+(93)*(x22)) )*((x11)**(2))+((((30)*((x22)**(2)))-((30)*(x22))) )*(x11)) )*((x12)**(5))+(((((-((81)*((x22)**(3)))+(123)*((x22)**(2)))-((42)*(x22))) )*((x11)**(4))+((((162)*((x22)**(3)))-((246)*((x22)**(2)))+(84)*(x22)) )*((x11)**(3))+(((-((81)*((x22)**(3)))+(123)*((x22)**(2)))-((42)*(x22))) )*((x11)**(2))) )*((x12)**(3))+((((((33)*((x22)**(4)))-((66)*((x22)**(3)))+(33)*((x22)**(2))) )*((x11)**(5))+(((-((84)*((x22)**(4)))+(168)*((x22)**(3)))-((84)*((x22)**(2)))) )*((x11)**(4))+((((69)*((x22)**(4)))-((138)*((x22)**(3)))+(69)*((x22)**(2))) )*((x11)**(3))+(((-((18)*((x22)**(4)))+(36)*((x22)**(3)))-((18)*((x22)**(2)))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),((74)*((x12)**(10))+((((-((49)*(x22))+28) )*(x11)+((28)*(x22))-(16)) )*((x12)**(8))+(((((-((274)*((x22)**(2)))+(275)*(x22))-(16)) )*((x11)**(2))+((((275)*((x22)**(2)))-((276)*(x22))+16) )*(x11)+-((16)*((x22)**(2)))+(16)*(x22)) )*((x12)**(6))+((((((448)*((x22)**(3)))-((688)*((x22)**(2)))+(240)*(x22)) )*((x11)**(3))+(((-((688)*((x22)**(3)))+(1056)*((x22)**(2)))-((368)*(x22))) )*((x11)**(2))+((((240)*((x22)**(3)))-((368)*((x22)**(2)))+(128)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((248)*((x22)**(4)))+(511)*((x22)**(3)))-((311)*((x22)**(2)))+(48)*(x22)) )*((x11)**(4))+(((((511)*((x22)**(4)))-((1052)*((x22)**(3)))+(637)*((x22)**(2)))-((96)*(x22))) )*((x11)**(3))+(((-((311)*((x22)**(4)))+(637)*((x22)**(3)))-((374)*((x22)**(2)))+(48)*(x22)) )*((x11)**(2))+((((48)*((x22)**(4)))-((96)*((x22)**(3)))+(48)*((x22)**(2))) )*(x11)) )*((x12)**(2))+(((((49)*((x22)**(5)))-((126)*((x22)**(4)))+(105)*((x22)**(3)))-((28)*((x22)**(2)))) )*((x11)**(5))+(((-((126)*((x22)**(5)))+(324)*((x22)**(4)))-((270)*((x22)**(3)))+(72)*((x22)**(2))) )*((x11)**(4))+(((((105)*((x22)**(5)))-((270)*((x22)**(4)))+(225)*((x22)**(3)))-((60)*((x22)**(2)))) )*((x11)**(3))+(((-((28)*((x22)**(5)))+(72)*((x22)**(4)))-((60)*((x22)**(3)))+(16)*((x22)**(2))) )*((x11)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),((16)*((x12)**(11))+((((-((32)*(x22))+17) )*(x11)+((17)*(x22))-(9)) )*((x12)**(9))+((((-((32)*((x22)**(2)))+(30)*(x22)+1) )*((x11)**(2))+(((((30)*((x22)**(2)))-((28)*(x22)))-(1)) )*(x11)+((x22)**(2))-(x22)) )*((x12)**(7))+((((((128)*((x22)**(3)))-((192)*((x22)**(2)))+(64)*(x22)) )*((x11)**(3))+(((-((192)*((x22)**(3)))+(288)*((x22)**(2)))-((96)*(x22))) )*((x11)**(2))+((((64)*((x22)**(3)))-((96)*((x22)**(2)))+(32)*(x22)) )*(x11)) )*((x12)**(5))+(((((-((112)*((x22)**(4)))+(226)*((x22)**(3)))-((131)*((x22)**(2)))+(17)*(x22)) )*((x11)**(4))+(((((226)*((x22)**(4)))-((456)*((x22)**(3)))+(264)*((x22)**(2)))-((34)*(x22))) )*((x11)**(3))+(((-((131)*((x22)**(4)))+(264)*((x22)**(3)))-((150)*((x22)**(2)))+(17)*(x22)) )*((x11)**(2))+((((17)*((x22)**(4)))-((34)*((x22)**(3)))+(17)*((x22)**(2))) )*(x11)) )*((x12)**(3))+(((((((32)*((x22)**(5)))-((81)*((x22)**(4)))+(66)*((x22)**(3)))-((17)*((x22)**(2)))) )*((x11)**(5))+(((-((81)*((x22)**(5)))+(205)*((x22)**(4)))-((167)*((x22)**(3)))+(43)*((x22)**(2))) )*((x11)**(4))+(((((66)*((x22)**(5)))-((167)*((x22)**(4)))+(136)*((x22)**(3)))-((35)*((x22)**(2)))) )*((x11)**(3))+(((-((17)*((x22)**(5)))+(43)*((x22)**(4)))-((35)*((x22)**(3)))+(9)*((x22)**(2))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1))]])
  p22=np.array([[0,0,0,1,0,0,0,0],[0,0,0,0,0,0,1,0],[0,0,0,0,1,0,0,0],[(-3/2)/(((x22)**(2))-(x22)),0,(-((3/2)*(x12)))/(((x22)**(2))-(x22)),(-((7/2)*(x22))+2)/(((x22)**(2))-(x22)),(((-(x22)+1/2) )*(x12))/(((x22)**(2))-(x22)),0,(-((x12)**(2)))/(((x22)**(2))-(x22)),0],[0,(((((-((6)*(x22))+3) )*((x11)**(2))+((((6)*(x22))-(3)) )*(x11)) )*(x12))/(((d5)*((x22)**(2)))-((d5)*(x22))),(-3)/(((x22)**(2))-(x22)),(((((6)*(x22))-(3)) )*((x12)**(3)))/(((d5)*((x22)**(2)))-((d5)*(x22))),(((((3/2)*(x22))-(1/2)) )*((x12)**(4))+((((9/2)*((x22)**(3)))-((7)*((x22)**(2)))+(5/2)*(x22)) )*((x11)**(2))+(((-((9/2)*((x22)**(3)))+(7)*((x22)**(2)))-((5/2)*(x22))) )*(x11))/(((d5)*((x22)**(2)))-((d5)*(x22))),(((((-((6)*(x22))+3) )*((x11)**(2))+((((6)*(x22))-(3)) )*(x11)) )*((x12)**(2)))/(((d5)*((x22)**(2)))-((d5)*(x22))),(-((8)*((x12)**(5)))+((((((14)*(x22))-(7)) )*(x11)+-((8)*(x22))+4) )*((x12)**(3))+(((((-((6)*((x22)**(2)))+(7)*(x22))-(4)) )*((x11)**(2))+((((6)*((x22)**(2)))-((7)*(x22))+4) )*(x11)) )*(x12))/(((d5)*((x22)**(2)))-((d5)*(x22))),(-((x12)**(6))+((((((4)*(x22))-(2)) )*(x11)+-((2)*(x22))+1) )*((x12)**(4))+(((((-((3)*((x22)**(2)))+(3)*(x22))-(1)) )*((x11)**(2))+((((3)*((x22)**(2)))-((3)*(x22))+1) )*(x11)) )*((x12)**(2)))/(((d5)*((x22)**(2)))-((d5)*(x22)))],[0,0,0,0,0,0,0,1],[0,(((3/2)*((x11)**(2)))-((3/2)*(x11)))/(d5),0,(-((3/2)*((x12)**(2))))/(d5),(-((3/2)*((x12)**(3))))/(d5),(((((3/2)*((x11)**(2)))-((3/2)*(x11))) )*(x12))/(d5),(((-((7/2)*(x11))+2) )*((x12)**(2))+((((7/2)*(x22))-(2)) )*((x11)**(2))+((-((7/2)*(x22))+2) )*(x11))/(d5),(((-(x11)+1/2) )*((x12)**(3))+(((((x22)-(1/2)) )*((x11)**(2))+((-(x22)+1/2) )*(x11)) )*(x12))/(d5)],[(((-((9)*(x11))+9/2) )*((x12)**(3))+((((((9)*(x22))-(9/2)) )*((x11)**(2))+((-((9)*(x22))+9/2) )*(x11)) )*(x12))/((((d4)*(d3))*(d2))*(d1)),(((((24)*((x11)**(2)))-((24)*(x11))) )*((x12)**(7))+((((-((69)*(x22))+36) )*((x11)**(3))+((((207/2)*(x22))-(54)) )*((x11)**(2))+((-((69/2)*(x22))+18) )*(x11)) )*((x12)**(5))+((((((66)*((x22)**(2)))-((135/2)*(x22))+18) )*((x11)**(4))+(((-((267/2)*((x22)**(2)))+(273/2)*(x22))-(36)) )*((x11)**(3))+((((147/2)*((x22)**(2)))-((75)*(x22))+18) )*((x11)**(2))+((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)) )*((x12)**(3))+(((((-((21)*((x22)**(3)))+(63/2)*((x22)**(2)))-((21/2)*(x22))) )*((x11)**(5))+((((54)*((x22)**(3)))-((81)*((x22)**(2)))+(27)*(x22)) )*((x11)**(4))+(((-((45)*((x22)**(3)))+(135/2)*((x22)**(2)))-((45/2)*(x22))) )*((x11)**(3))+((((12)*((x22)**(3)))-((18)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((27)*(x11))+27/2) )*((x12)**(4))+((((((27)*(x22))-(27/2)) )*((x11)**(2))+((-((27)*(x22))+27/2) )*(x11)) )*((x12)**(2)))/((((d4)*(d3))*(d2))*(d1)),(-((12)*((x12)**(9)))+((((((48)*(x22))-(24)) )*(x11)+-((24)*(x22))+12) )*((x12)**(7))+(((((-((69)*((x22)**(2)))+(69)*(x22))-(12)) )*((x11)**(2))+((((141/2)*((x22)**(2)))-((141/2)*(x22))+12) )*(x11)+-((6)*((x22)**(2)))+(6)*(x22)) )*((x12)**(5))+((((((42)*((x22)**(3)))-((129/2)*((x22)**(2)))+(45/2)*(x22)) )*((x11)**(3))+(((-((129/2)*((x22)**(3)))+(99)*((x22)**(2)))-((69/2)*(x22))) )*((x11)**(2))+((((45/2)*((x22)**(3)))-((69/2)*((x22)**(2)))+(12)*(x22)) )*(x11)) )*((x12)**(3))+(((((-((9)*((x22)**(4)))+(39/2)*((x22)**(3)))-((33/2)*((x22)**(2)))+(6)*(x22)) )*((x11)**(4))+(((((18)*((x22)**(4)))-((39)*((x22)**(3)))+(33)*((x22)**(2)))-((12)*(x22))) )*((x11)**(3))+(((-((9)*((x22)**(4)))+(39/2)*((x22)**(3)))-((33/2)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(-((9)*((x12)**(10)))+((((((36)*(x22))-(18)) )*(x11)+-((18)*(x22))+9) )*((x12)**(8))+(((((-((63)*((x22)**(2)))+(63)*(x22))-(9)) )*((x11)**(2))+((((129/2)*((x22)**(2)))-((129/2)*(x22))+9) )*(x11)+-((6)*((x22)**(2)))+(6)*(x22)) )*((x12)**(6))+((((((54)*((x22)**(3)))-((165/2)*((x22)**(2)))+(57/2)*(x22)) )*((x11)**(3))+(((-((165/2)*((x22)**(3)))+(126)*((x22)**(2)))-((87/2)*(x22))) )*((x11)**(2))+((((57/2)*((x22)**(3)))-((87/2)*((x22)**(2)))+(15)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((18)*((x22)**(4)))+(75/2)*((x22)**(3)))-((57/2)*((x22)**(2)))+(9)*(x22)) )*((x11)**(4))+(((((36)*((x22)**(4)))-((75)*((x22)**(3)))+(57)*((x22)**(2)))-((18)*(x22))) )*((x11)**(3))+(((-((18)*((x22)**(4)))+(75/2)*((x22)**(3)))-((57/2)*((x22)**(2)))+(9)*(x22)) )*((x11)**(2))) )*((x12)**(2)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((((21)*((x11)**(2)))-((21)*(x11))) )*((x12)**(8))+((((-((69)*(x22))+36) )*((x11)**(3))+((((207/2)*(x22))-(54)) )*((x11)**(2))+((-((69/2)*(x22))+18) )*(x11)) )*((x12)**(6))+((((((72)*((x22)**(2)))-((147/2)*(x22))+18) )*((x11)**(4))+(((-((291/2)*((x22)**(2)))+(297/2)*(x22))-(36)) )*((x11)**(3))+((((159/2)*((x22)**(2)))-((81)*(x22))+18) )*((x11)**(2))+((-((6)*((x22)**(2)))+(6)*(x22)) )*(x11)) )*((x12)**(4))+(((((-((21)*((x22)**(3)))+(63/2)*((x22)**(2)))-((21/2)*(x22))) )*((x11)**(5))+((((54)*((x22)**(3)))-((81)*((x22)**(2)))+(27)*(x22)) )*((x11)**(4))+(((-((45)*((x22)**(3)))+(135/2)*((x22)**(2)))-((45/2)*(x22))) )*((x11)**(3))+((((12)*((x22)**(3)))-((18)*((x22)**(2)))+(6)*(x22)) )*((x11)**(2))) )*((x12)**(2))+(((-((3)*((x22)**(4)))+(6)*((x22)**(3)))-((3)*((x22)**(2)))) )*((x11)**(6))+((((9)*((x22)**(4)))-((18)*((x22)**(3)))+(9)*((x22)**(2))) )*((x11)**(5))+(((-((9)*((x22)**(4)))+(18)*((x22)**(3)))-((9)*((x22)**(2)))) )*((x11)**(4))+((((3)*((x22)**(4)))-((6)*((x22)**(3)))+(3)*((x22)**(2))) )*((x11)**(3)))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((102)*(x11))+53) )*((x12)**(9))+((((((291)*(x22))-(153)) )*((x11)**(2))+((-((605/2)*(x22))+159) )*(x11)+((46)*(x22))-(24)) )*((x12)**(7))+(((((-((297)*((x22)**(2)))+(631/2)*(x22))-(90)) )*((x11)**(3))+((((464)*((x22)**(2)))-((492)*(x22))+138) )*((x11)**(2))+(((-((359/2)*((x22)**(2)))+(189)*(x22))-(48)) )*(x11)+((8)*((x22)**(2)))-((8)*(x22))) )*((x12)**(5))+(((((((129)*((x22)**(3)))-((208)*((x22)**(2)))+(239/2)*(x22))-(24)) )*((x11)**(4))+(((-((537/2)*((x22)**(3)))+(432)*((x22)**(2)))-((489/2)*(x22))+48) )*((x11)**(3))+(((((339/2)*((x22)**(3)))-((270)*((x22)**(2)))+(141)*(x22))-(24)) )*((x11)**(2))+(((-((30)*((x22)**(3)))+(46)*((x22)**(2)))-((16)*(x22))) )*(x11)) )*((x12)**(3))+(((((-((21)*((x22)**(4)))+(91/2)*((x22)**(3)))-((77/2)*((x22)**(2)))+(14)*(x22)) )*((x11)**(5))+(((((54)*((x22)**(4)))-((117)*((x22)**(3)))+(99)*((x22)**(2)))-((36)*(x22))) )*((x11)**(4))+(((-((45)*((x22)**(4)))+(195/2)*((x22)**(3)))-((165/2)*((x22)**(2)))+(30)*(x22)) )*((x11)**(3))+(((((12)*((x22)**(4)))-((26)*((x22)**(3)))+(22)*((x22)**(2)))-((8)*(x22))) )*((x11)**(2))) )*(x12))/(((((d5)*(d4))*(d3))*(d2))*(d1)),(((-((39/2)*(x11))+19/2) )*((x12)**(10))+((((((147/2)*(x22))-(75/2)) )*((x11)**(2))+((-((147/2)*(x22))+75/2) )*(x11)+((23/2)*(x22))-(6)) )*((x12)**(8))+(((((-((99)*((x22)**(2)))+(101)*(x22))-(24)) )*((x11)**(3))+((((150)*((x22)**(2)))-((153)*(x22))+36) )*((x11)**(2))+(((-((109/2)*((x22)**(2)))+(111/2)*(x22))-(12)) )*(x11)+((2)*((x22)**(2)))-((2)*(x22))) )*((x12)**(6))+(((((((51)*((x22)**(3)))-((78)*((x22)**(2)))+(77/2)*(x22))-(6)) )*((x11)**(4))+(((-((104)*((x22)**(3)))+(159)*((x22)**(2)))-((78)*(x22))+12) )*((x11)**(3))+(((((61)*((x22)**(3)))-((93)*((x22)**(2)))+(87/2)*(x22))-(6)) )*((x11)**(2))+(((-((8)*((x22)**(3)))+(12)*((x22)**(2)))-((4)*(x22))) )*(x11)) )*((x12)**(4))+(((((-((3/2)*((x22)**(4)))+(3)*((x22)**(3)))-((5)*((x22)**(2)))+(7/2)*(x22)) )*((x11)**(5))+(((((9/2)*((x22)**(4)))-((9)*((x22)**(3)))+(27/2)*((x22)**(2)))-((9)*(x22))) )*((x11)**(4))+(((-((9/2)*((x22)**(4)))+(9)*((x22)**(3)))-((12)*((x22)**(2)))+(15/2)*(x22)) )*((x11)**(3))+(((((3/2)*((x22)**(4)))-((3)*((x22)**(3)))+(7/2)*((x22)**(2)))-((2)*(x22))) )*((x11)**(2))) )*((x12)**(2))+(((-((9/2)*((x22)**(5)))+(23/2)*((x22)**(4)))-((19/2)*((x22)**(3)))+(5/2)*((x22)**(2))) )*((x11)**(6))+(((((27/2)*((x22)**(5)))-((69/2)*((x22)**(4)))+(57/2)*((x22)**(3)))-((15/2)*((x22)**(2)))) )*((x11)**(5))+(((-((27/2)*((x22)**(5)))+(69/2)*((x22)**(4)))-((57/2)*((x22)**(3)))+(15/2)*((x22)**(2))) )*((x11)**(4))+(((((9/2)*((x22)**(5)))-((23/2)*((x22)**(4)))+(19/2)*((x22)**(3)))-((5/2)*((x22)**(2)))) )*((x11)**(3)))/(((((d5)*(d4))*(d3))*(d2))*(d1))]])
#------
  p=p11*dx[0]+p12*dx[1]+p22*dx[2]
  return p@f


#cook_Q_for_hgm(dat,small_covar=1e-3,threshould=1e-5,initial_point=np.array([[-1,0,-1]]),even=True):
#  defined in 2024-09-12-batch-erf.py
# 戻り値 np.array([[x11,x12,x22,idx0],[x11,x12,x22,idx1],...])
#   x が sort されてる. idx は元のデータで何番目か?

# dat は cook_Q_for_hgm の戻り値を使う
#  qsize  何個まとめて計算するか?  -1 は全部.
def batch_hgm_erf(dat,qsize=-1,rtol = 1e-10, atol = 1e-10):
  global Q
  global N_calls 
  global Last_value
  Q=dat
  if (qsize < 0): qsize=Q.shape[0]
  Q=Q[0:qsize]
  if (qsize <= 20):
    print(Q)
  print('Data size = ',Q.shape)
  NN = Q.shape[0]
  QQ=(Q.T)[0:-1] # remove index
  Q=QQ.T
  Q_orig=Q.copy()
  N_calls=0

  t_span=[0.0,NN-2]
  # tmp_erf.py
  iv=[1/2,5/8,1/2*np.pi,5/8,3/4*np.pi,3/4*np.pi,25/32,9/8*np.pi]
  start=time.time()
  #print(list(range(NN-1)))
  if atol == 0:
      sol = solve_ivp(f_erf,t_span,iv,method='RK45',t_eval=list(range(NN-1)),rtol=rtol)
  #  sol = solve_ivp(f_erf,t_span,iv,method='RK45',t_eval=list(range(NN-1)),rtol=1e-10,atol=1e-10)
  else:
    sol = solve_ivp(f_erf,t_span,iv,method='RK45',t_eval=list(range(NN-1)),rtol=rtol,atol=atol)
  end=time.time(); print('Time=',end-start,'s')
  print(sol)
  print('sol.y[0,-1]=',sol.y[0,-1])
  Last_value=sol.y[0,-1]
  print('N_calls=',N_calls)
  print('Q[NN-2]=',Q[NN-2])
  return sol

def batch_hgm_erf2(x,x0,iv,rtol = 1e-10,atol = 1e-10):
  global N_calls 
  global Last_value
  N_calls=0

  t_span=[0.0,1.0]
  # tmp_erf.py
  iv=iv
  start=time.time()
  #print(list(range(NN-1)))

#  sol = solve_ivp(f_erf,t_span,iv,method='RK45',t_eval=list(range(NN-1)),rtol=1e-10,atol=1e-10)
  sol = solve_ivp(f_erf2,t_span,iv,method='RK45',args = (x[0],x[1],x[2],x0[0],x0[1],x0[2]),rtol=rtol,atol=atol)
  end=time.time(); print('Time=',end-start,'s')
  print(sol)
  print('sol.y[0,-1]=',sol.y[0,-1])
  Last_value=sol.y[0,-1]
  print('N_calls=',N_calls)
  return sol
# test codes


"""
npyName='tmp-Q-data-may-remove'
print('Loading %s.npy' % (npyName))
dat=np.load(npyName+'.npy')
#sol=batch_hgm_erf(dat,qsize=30)
sol=batch_hgm_erf(dat)

print('\nComputing the each steps straightly.')
start=time.time()
N_calls=0
npyName='tmp-Q-data-may-remove'
print('Loading %s.npy' % (npyName))
Q_orig=np.load(npyName+'.npy')
QQ_orig=(Q_orig.T)[0:-1] # remove index
Q_orig=QQ_orig.T


iv=[1/2,5/8,1/2*np.pi,5/8,3/4*np.pi,3/4*np.pi,25/32,9/8*np.pi]
NN = Q.shape[0]
for i in range(1,NN-1):
  Q=[Q_orig[0],Q_orig[i],Q_orig[i]]
  t_span=[0.0,1.0]
  sol2 = solve_ivp(f_erf,t_span,iv,method='RK45',rtol=1e-10,atol=1e-10)
end=time.time(); print('Time=',end-start,'s')
print('sol2.y[0,-1]=',sol2.y[0,-1])
last_value2=sol2.y[0,-1]
print('N_calls=',N_calls)
print('diff of last value=',last_value2-Last_value)
print('ratio of last value=',(last_value2-Last_value)/Last_value)
"""
# end of test codes.
